/**
 * Debug.class.js v0.2 - Debug utility class
 *
 *	vim: set ft=javascript:
 *	Author: M.Satoh
 *	Last Change: 18-Nov-2009.
 */

(function(){
	var _arrListener = new Array();
	var _enable = true;

	this.on = function() {
		_enable = true;
	};

	this.off = function() {
		_enable = false;
	};

	// Xi[(o͐)ǉ
	this.addListener = function(param) {
		var obj = null;
		if (typeof(param) == "object" && isString(param.innerHTML)) {
			obj = new HtmlListener();
		}
		else if (isString(param) && param.match(/\.(txt|log)$/i)) {
			obj = new TextListener();
		}

		if (obj) {
			obj.initialize.apply(obj, arguments);
			_arrListener.push(obj);
		}
	};

	// I
	this.close = function() {
		foreach(_arrListener, function(i, v) {
			v.close();
		});
		_arrListener.length = 0;
	};

	// o͂(sȂ)
	this.write = function() {
		if (_enable) {
			var args = arguments;
			foreach(_arrListener, function(i, v) {
				v.write.apply(v, args);
			});
		}
	};

	// o͂(s)
	this.writeLine = function() {
		if (_enable) {
			var args = arguments;
			foreach(_arrListener, function(i, v) {
				v.writeLine.apply(v, args);
			});
		}
	};

	// o͓ẽNA
	this.clear = function() {
		if (_enable) {
			foreach(_arrListener, function(i, v) {
				v.clear();
			});
		}
	};

	//===== [JNX` =====//
	// innerHTMLɑ΂ďo͂
	function HtmlListener() {
		var _elem;

		this.initialize = function(elem) {
			_elem = elem;
		};

		this.write = function() {
			foreach(arguments, function(i, v) {
				_elem.innerHTML += v;
			});
		};

		this.writeLine = function() {
			this.write.apply(this, arguments);
			_elem.innerHTML += "<br/>";
		};

		this.clear = function() {
			_elem.innerHTML = "";
		};

		this.close = function() {
		};
	};

	// eLXgt@Cɑ΂ďo͂
	function TextListener() {
		var _objFile;
		
		this.initialize = function(fname) {
			var objFso = new ActiveXObject("Scripting.FileSystemObject");
			if (arguments.length == 1) {	// t@Ĉݎw
				_objFile = objFso.OpenTextFile(fname, 2, true);
			}
			else {
				_objFile = objFso.OpenTextFile(fname, 8, true);
			}
		};

		this.write = function() {
			foreach(arguments, function(i, v) {
				_objFile.Write(v);
			});
		};

		this.writeLine = function() {
			this.write.apply(this, arguments);
			_objFile.Write("\r\n");
		};

		this.clear = function() {
		};

		this.close = function() {
			_objFile.Close();
		};
	};

}).apply(WSH.Debug);

