/**
 * Shell.class.js v0.1 - WshShell wrapper class
 * 
 * vim: set ft=javascript: Author: M.Satoh Last Change: 04-Nov-2009.
 */

(function() {
	var _objShell = new ActiveXObject("WScript.Shell");

	/**
	 * w^Cg̃EBhEANeBuɂ
	 * 
	 * @return true 
	 * @return false EBhEȂ
	 */
	this.AppActivate = function(appTitle) {
		return _objShell.AppActivate(appTitle);
	};

	/**
	 * ϐ(%`%)WJ
	 * 
	 * @return WJꂽ
	 */
	this.ExpandEnvironmentStrings = function(str) {
		return _objShell.ExpandEnvironmentStrings(str);
	};

	/**
	 * bZ[W{bNX\
	 * 
	 * @return [U{^l
	 */
	this.Popup = function(text, wait, title, type) {
		switch (arguments.length) {
		case 1:
			return _objShell.Popup(text);
		case 2:
			return _objShell.Popup(text, wait);
		case 3:
			return _objShell.Popup(text, wait, title);
		}
		return _objShell.Popup(text, wait, title, type);
	};
	// {^̎
	WSH.PopupButtons = function() {
		return {
			OKOnly : 0, // [OK]
			OKCancel : 1, // [OK][LZ]
			AbortRetryIgnore : 2, // [~][Ďs][]
			YesNoCancel : 3, // [͂][][LZ]
			YesNo : 4, // [͂][]
			RetryCancel : 5
		// [Ďs][LZ]
		};
	}();
	// ACR̎
	WSH.PopupIcon = function() {
		return {
			None : 0,
			Critical : 16, // ~
			Question : 32, // H
			Exclamation : 48, // I
			Information : 64
		// 
		};
	}();
	// ̃{^
	WSH.PopupDefaultButton = function() {
		return {
			DefaultButton1 : 0,
			DefaultButton2 : 256,
			DefaultButton3 : 512,
			DefaultButton4 : 768
		};
	}();
	// \@
	WSH.PopupModal = function() {
		return {
			ApplicationModal : 0,
			SystemModal : 4096
		};
	}();
	// ꂽ{^
	WSH.PopupResult = function() {
		return {
			OK : 1,
			Cancel : 2,
			Abort : 3,
			Retry : 4,
			Ignore : 5,
			Yes : 6,
			No : 7
		};
	}();

	/**
	 * WXg֏
	 */
	this.RegWrite = function(name, value, type) {
		switch (arguments.length) {
		case 2:
			_objShell.RegWrite(name, value);
			break;
		default:
			_objShell.RegWrite(name, value, type);
			break;
		}
	};

	/**
	 * WXg폜
	 */
	this.RegDelete = function(name) {
		_objShell.RegDelete(name);
	};

	/**
	 * WXgǂݍ
	 * 
	 * @return ǂݎl
	 */
	this.RegRead = function(name) {
		return _objShell.RegRead(name);
	};

	/**
	 * AvP[V܂̓t@CJ
	 * 
	 * @param cmd
	 *            [string] t@C܂͎sR}h
	 * @param style
	 *            [int] EBhEX^C
	 * @param wait
	 *            [bool] true:^false:񓯊
	 */
	this.Run = function(cmd, style, wait) {
		switch (arguments.length) {
		case 1:
			return _objShell.Run(cmd);
			break;
		case 2:
			return _objShell.Run(cmd, style);
			break;
		default:
			return _objShell.Run(cmd, style, wait);
			break;
		}
	};
	// EBhEX^C
	WSH.WindowStyle = function() {
		return {
			Hide : 0, // \
			Normal : 1, // ʏ
			Minimized : 2, // ŏ
			Maximized : 3, // ő剻
			NormalInActive : 4, // ʏ(ANeBu)
			Focus : 5, // ݂̈ʒuƃTCY
			MinimizedInActive : 6
		// ŏ(ANeBu)
		};
	}();

	/**
	 * qR}hVFŃAvP[Vs
	 */
	this.Exec = function(cmd) {
		return _objShell.Exec(cmd);
	};

	/**
	 * ANeBuEBhEɎw̃L[R[h𑗂
	 */
	this.SendKeys = function(str) {
		_objShell.SendKeys(str);
	};

	/**
	 * V[gJbg̍쐬
	 * 
	 * @param name
	 *            [string] V[gJbgt@C(*.lnk/*.url)
	 * @return WshShortCutIuWFNg/WshUrlShortCutIuWFNg
	 */
	this.CreateShortCut = function(name) {
		return _objShell.CreateShortCut(name);
	};

	/**
	 * JgfBNg擾Eݒ
	 */
	this.CurrentDirectory = function(dir) {
		if (arguments.length == 0) { // Read
			return _objShell.CurrentDirectory;
		} else {
			_objShell.CurrentDirectory = dir;
		}
	};

	/**
	 * w肳ꂽϐ̒l擾
	 * 
	 * @param name
	 *            [string] "TEMP"Ƃ
	 * @param type
	 *            [string] EnvironmentTarget̂ǂꂩ ȗProcess
	 */
	this.GetEnvironmentVariable = function(name, type) {
		if (arguments.length == 1) {
			type = WSH.EnvironmentTarget.Process;
		}
		return _objShell.Environment(type).Item(name);
	};
	WSH.EnvironmentTarget = function() {
		return {
			System : "system",
			User : "user",
			Volatile : "volatile",
			Process : "process"
		};
	}();

	/**
	 * ϐ name ̒l value ɐݒ܂͍폜
	 * 
	 * @param name
	 *            [string] "TEMP"Ƃ
	 * @param value
	 *            [variant] ݒl null܂͏ȗ͊ϐ폜
	 * @param type
	 *            [string] EnvironmentTarget̂ǂꂩ ȗProcess
	 */
	this.SetEnvironmentVariable = function(name, value, type) {
		if (arguments.length < 3) {
			type = WSH.EnvironmentTarget.Process;
		}
		if (typeof value === "undefined" || value === null) {
			_objShell.Environment(type).Remove(name);
		} else {
			_objShell.Environment(type).Item(name) = value;
		}
	};

	/**
	 * ׂĂ̊ϐAzzŎ擾
	 * 
	 * @param type
	 *            [string] EnvironmentTarget̂ǂꂩ ȗProcess
	 */
	this.GetEnvironmentVariables = function(type) {
		if (arguments.length == 0) {
			type = WSH.EnvironmentTarget.Process;
		}
		var env = _objShell.Environment(type);
		var ret = {};
		foreach(env, function(it) {
			if (it.match(/^([^=]+)=(.*)$/)) {
				ret[RegExp.$1] = RegExp.$2;
			}
		});
		return ret;
	};

	/**
	 * tH_̃pX擾
	 */
	this.GetFolderPath = function(name) {
		if (isNumber(name)) {
			var objFso = new ActiveXObject("Scripting.FileSystemObject");
			return objFso.GetSpecialFolder(name);
		}
		if (name.match(/^%.*%$/)) {
			return this.ExpandEnvironmentStrings(name);
		}
		var key = (name.match(/^common/i)) ? "HKLM" : "HKCU";
		key += "\\\SOFTWARE\\Microsoft\\Windows\\CurrentVersion";
		key += "\\explorer\\Shell Folders\\";
		key += name;
		return this.ExpandEnvironmentStrings(this.RegRead(key));
	};
	WSH.SpecialFolder = function() {
		return {
			// HKCU擾
			ApplicationData : "AppData",
			InternetCache : "Cache",
			Cookies : "Cookies",
			DesktopDirectory : "Desktop",
			Favorites : "Favorites",
			Fonts : "Fonts",
			History : "History",
			LocalApplicationData : "Local AppData",
			MyMusic : "My Music",
			MyPictures : "My Pictures",
			MyVideo : "My Video",
			NetHood : "NetHood",
			Personal : "Personal",
			PrintHood : "PrintHood",
			Programs : "Programs",
			Recent : "Recent",
			SendTo : "SendTo",
			StartMenu : "Start Menu",
			Startup : "Startup",
			Templates : "Templates",
			// HKLM擾
			CommonApplicationData : "Common AppData",
			CommonDesktopDirectory : "Common Desktop",
			CoomonDocuments : "Common Documents",
			CommonMusic : "CommonMusic",
			CommonPictures : "CommonPictures",
			CommonPrograms : "Common Programs",
			CommonStartMenu : "Common Start Menu",
			CommonStartup : "Common Startup",
			CommonTemplates : "Common Templates",
			CommonVideo : "CommonVideo",
			// FSO.GetSpecialFolder()擾
			Windows : 0,
			System : 1,
			Temporary : 2,
			// ϐ擾
			ProgramFiles : "%ProgramFiles%",
			CommonProgramFiles : "%CommonProgramFiles%"
		};
	}();
}).apply(WSH.Shell);
