// vim: set ft=javascript:

//===== O[oϐ(萔) =====//
var N = 3;
var NN = N * N;
var NBSP = "&nbsp;";
var CreateGameCmd = "javaw.exe -cp .\\lib\\util.jar util.CreateGame ";

/*******************************************************************************
 * Z̃NX
 ******************************************************************************/
var Cell = Class.create();
// [static]ID쐬
Cell.makeId = function(index) {
	return "c" + index;
};
/**
 * RXgN^
 * 
 * @param arg
 *            [Number] ʒu
 * @param arg
 *            [DOMElement] Z\
 *            <td>vf
 * @param arg
 *            [Number, Number] ʒu(x, y)
 */
Cell.prototype.initialize = function(arg) {
	this.index = 0;
	this.id = "";
	if (arguments.length == 2) {
		arg = arguments[0] + (arguments[1] * NN);
	}
	if (isNumber(arg)) {
		this.index = arg;
		this.id = Cell.makeId(arg);
	} else if (isString(arg.id)) {
		this.id = arg.id;
		this.index = parseInt(arg.id.match(/\d+$/));
	} else {
		throw new Error("Cell(" + arg + ")͕sł");
	}
};
/**
 * l擾
 */
Cell.prototype.getValue = function() {
	var ret = $(this.id).innerHTML;
	return (ret.match(/^\d+$/) && ret != "0") ? parseInt(ret) : 0;
};
/**
 * lݒ肷
 */
Cell.prototype.setValue = function(v) {
	v = parseInt(v);
	$(this.id).innerHTML = (isNaN(v) || v == 0) ? NBSP : v;
};
/**
 * l𑝉()
 * 
 * @return ()̒l
 */
Cell.prototype.addValue = function(v) {
	var value = this.getValue() + v;
	// ␳
	if (value < 0) {
		value = NN;
	} else if (value > NN) {
		value = 0;
	}
	this.setValue(value);
	return value;
};
/**
 * qg邩ׂ
 */
Cell.prototype.isHint = function() {
	return $(this.id).className.match(/\b(hint)\b/) ? true : false;
};
/**
 * qgt^/D
 */
Cell.prototype.setHint = function(flag, v) {
	$(this.id).className = $(this.id).className.replace(/\b(hint)\b/g, "");
	if (flag) {
		$(this.id).className += " hint";
		if (arguments.length == 2) {
			this.setValue(v);
		}
	}
};
/**
 * nCCgt^/D
 */
Cell.prototype.setHilight = function(flag) {
	$(this.id).className = $(this.id).className.replace(/\b(hilight)\b/g, "");
	if (flag) {
		$(this.id).className += " hilight";
	}
};
/**
 * tH[JX邩ׂ
 */
Cell.prototype.isFocus = function() {
	return $(this.id).className.match(/\b(focus)\b/) ? true : false;
};
/**
 * tH[JXt^/D
 */
Cell.prototype.setFocus = function(flag) {
	$(this.id).className = $(this.id).className.replace(/\b(focus)\b/g, "");
	if (flag) {
		$(this.id).className += " focus";
	}
};
/**
 * NbNCxg
 * 
 * @return T/F = ύXꂽ/͕ύXȂ
 */
Cell.prototype.OnClick = function(bLeft) {
	// hilightt^
	this.setHilight(true);
	// ύX邩H
	var bChange = (!this.isHint() && this.isFocus());
	if (bChange) {
		// hintȊOŊfocusĂꍇ͐ύX
		this.addValue(bLeft ? 1 : -1);
	} else {
		// focus̕t^̂ݍs
		this.setFocus(true);
	}

	// ȊÕZ̏ԂύX邽߂ɁAFieldNX֓]
	Field.OnClick(this);

	return bChange;
};
// position
Cell.prototype.pos = function() {
	return this.index;
};
// position -> x
Cell.prototype.x = function() {
	return (this.index % NN);
};
// position -> y
Cell.prototype.y = function() {
	return Math.floor(this.index / NN);
};
// up
Cell.prototype.up = function() {
	return new Cell(this.index - NN);
};
// down
Cell.prototype.down = function() {
	return new Cell(this.index + NN);
};
// left
Cell.prototype.left = function() {
	return new Cell(this.index - 1);
};
// right
Cell.prototype.right = function() {
	return new Cell(this.index + 1);
};

/*******************************************************************************
 * tB[h(NN~NÑZ)̃NX
 ******************************************************************************/
var Field = Class.create();
Field.prototype.singleton = true;
// [static]SẴZNA
Field.clear = function() {
	for ( var i = 0; i < NN * NN; i++) {
		var cell = new Cell(i);
		cell.setValue(0);
		cell.setHint(false);
		cell.setHilight(false);
		cell.setFocus(false);
	}
};
// [static]tB[h쐬
Field.create = function(tbody, listner) {
	for ( var y = 0; y < NN; y++) {
		// <tr>vf쐬
		var tr = document.createElement("tr");
		for ( var x = 0; x < NN; x++) {
			// <td>vf쐬
			var td = document.createElement("td");
			td.id = Cell.makeId(x + y * NN);
			td.innerHTML = NBSP;
			td.className = "";
			if (x % N == 0) {
				td.className += " nx";
			}
			if (y % N == 0) {
				td.className += " ny";
			}
			// Cxgnhݒ肷
			td.attachEvent("onclick", function() {
				listner.Cell_OnClick(true);
			});
			td.attachEvent("ondblclick", function() {
				listner.Cell_OnClick(true);
			});
			td.attachEvent("oncontextmenu", function() {
				listner.Cell_OnClick(false);
			});
			// <tr>֒ǉ
			tr.appendChild(td);
		}
		// <tbody>֒ǉ
		tbody.appendChild(tr);
	}
};
// [static]NbNCxgnh
Field.OnClick = function(cell) {
	// NbNȂZ̃X^Cݒ
	var pos = cell.pos();
	var value = cell.getValue();
	for ( var i = 0; i < NN * NN; i++) {
		if (i != pos) {
			var cell2 = new Cell(i);
			// NbNꂽZƓȂnCCgAقȂ΃NA
			cell2.setHilight((cell2.getValue() == value) ? true : false);
			// tH[JXNA
			cell2.setFocus(false);
		}
	}
};
// [static]Ԃۑ
Field.serialize = function() {
	var _q = new Array(); // z
	var _a = new Array(); // 񓚔z
	for ( var i = 0; i < NN * NN; i++) {
		var cell = new Cell(i);
		var value = cell.getValue();
		if (cell.isHint()) {
			_q.push(value);
			_a.push("");
		} else {
			_q.push("");
			_a.push(value);
		}
	}
	return {
		q : _q.join(","),
		a : _a.join(",")
	};
};
// [static]Ԃ𕜌
Field.unserialize = function(q, a) {
	var _q = q.split(",");
	var _a = a.split(",");
	for ( var i = 0; i < NN * NN; i++) {
		var cell = new Cell(i);
		if (_q[i]) {
			cell.setHint(true, _q[i]);
		} else {
			cell.setValue(_a[i]);
		}
	}
};

/*******************************************************************************
 * iṽWbNNX
 ******************************************************************************/
var NumberPlace = Class.create();
NumberPlace.prototype.singleton = true;
// ȉAvCx[gIuWFNggp
(function() {
	/**
	 * 킹
	 */
	this.check = function() {
		var map = new Array();
		for ( var i = 0; i < NN * NN; i++) {
			var cell = new Cell(i);
			map[i] = cell.getValue();
			// 𓚃`FbN
			if (map[i] == 0) {
				return -1;
			}
			// d`FbN
			if (!check_rule(map[i], map, i)) {
				return false;
			}
		}
		return true;
	};
	// [private]d`FbN
	function check_rule(num, map, xy) {
		var pos;
		// Ȑd`FbN(0`݈ʒu̎O܂)
		for (pos = Math.floor(xy / NN) * NN; pos < xy; pos++) {
			if (map[pos] == num) {
				return false;
			}
		}
		// ^ȅd`FbN(0`݈ʒu̎O܂)
		for (pos = xy % NN; pos < xy; pos += NN) {
			if (map[pos] == num) {
				return false;
			}
		}
		// ubN̏d`FbN(x[Xʒu`݈ʒu̎O܂)
		var x = Math.floor((xy % NN) / N) * N;
		var y = Math.floor((xy / NN) / N) * N * NN;
		for ( var i = 0; i < N; i++, y += NN) {
			pos = x + y;
			for ( var j = 0; j < N; j++, pos++) {
				if (pos >= xy) {
					return true;
				}
				if (map[pos] == num) {
					return false;
				}
			}
		}
		return true;
	}
}).apply(NumberPlace);

/*******************************************************************************
 * XNvg̃CNX(Singleton)
 ******************************************************************************/
var MyScript = Script.create();
/**
 * RXgN^
 */
MyScript.prototype.initialize = function() {
	this.contextmenu = false;
};
/**
 * C֐(HTAł͎gpȂ)
 */
MyScript.prototype.main = function(argv) {
	echo("̃XNvg͒P̂ł͓삵܂B");
	WScript.Quit();
};
// ȉAvCx[gIuWFNggp
(function() {
	// ===== 萔 =====//
	var WIN_WIDTH = 400;
	var WIN_HEIGHT = 450;
	var APPNAME = "Puzzle";
	// ===== oϐ =====//
	var Debug = WSH.require("Debug");
	var Profile = WSH.require("Profile");
	var Playing = 0; // 0/1/2 = /쐬/𓚒

	/**
	 * window.onbeforeunload Cxgnh
	 */
	this.OnBeforeUnload = function(evt) {
		if (Playing != 0) {
			var ret = WSH.require("Shell").Popup("Q[ۑ܂H", 0, "mF",
					WSH.PopupButtons.YesNo | WSH.PopupIcon.Question);
			if (ret == WSH.PopupResult.Yes) {
				// Q[f[^Zbg
				Profile.set(APPNAME, Field.serialize());
			}
		}
		Profile.set(APPNAME, "hint", $("per_of_hint").value);
		Profile.save(APPNAME + ".ini");
		Debug.close();
	};

	/**
	 * window.onload Cxgnh
	 */
	this.OnLoad = function(evt) {
		window.resizeTo(WIN_WIDTH, WIN_HEIGHT);
		var self = this;
		// Debug.on();
		Debug.off();
		Debug.addListener($("debug"));
		Debug.t_count = 0;
		Debug.t_time = 0;
		// ݒǂݍ
		Profile.load(APPNAME + ".ini");
		$("per_of_hint").value = Profile.get(APPNAME, "hint", 50);
		// tB[h쐬
		Field.create($("Field"), this);
		// OȈԂ𕜌
		if (Profile.get(APPNAME, "q") && Profile.get(APPNAME, "a")) {
			var q = Profile.get(APPNAME, "q");
			var a = Profile.get(APPNAME, "a");
			Field.unserialize(q, a);
			Playing = 2;
		}
		Profile.remove(APPNAME, "q");
		Profile.remove(APPNAME, "a");
	};

	// Z̃NbN
	this.Cell_OnClick = function(bLeft) {
		if (Playing == 0) {
			return;
		}
		var cell = new Cell(event.srcElement);
		if (cell.OnClick(bLeft)) {
			Playing = 2;
		}
	};

	/**
	 * Field.onkeydown Cxgnh
	 */
	this.Field_OnKeyDown = function(evt) {
		switch (event.keyCode) {
		case 8: // Backspace
			echo("Backspace");
			break;
		case 32: // Space
			echo("Space");
			break;
		case 37: // Left
			echo("Left");
			break;
		case 38: // Up
			echo("Up");
			break;
		case 39: // Right
			echo("Right");
			break;
		case 40: // Down
			echo("Down");
			break;
		case 46: // Delete
			echo("Delete");
			break;
		case 48: // 0
		case 49: // 1
		case 50: // 2
		case 51: // 3
		case 52: // 4
		case 53: // 5
		case 54: // 6
		case 55: // 7
		case 56: // 8
		case 57: // 9
			echo(event.keyCode - 48);
			break;
		default:
			Debug.on();
			Debug.writeLine("-----");
			foreach(event, function(key, value) {
				Debug.writeLine(key, ":", value);
			});
			break;
		}
	};

	/**
	 * Button_Start.onclick Cxgnh
	 */
	this.Button_Start_OnClick = function(evt) {
		Lock();
		// qg擾
		var value = $("per_of_hint").value;
		if (!value.match(/^\d{1,2}$/) || parseInt(value) == 0) {
			echo("uqgvɂ1`99̐ݒ肵ĉB");
			Unlock();
			$("per_of_hint").focus();
			return;
		}
		if (Playing == 2) {
			WSH.require("Shell");
			var flag = WSH.PopupButtons.YesNo | WSH.PopupIcon.Question;
			var ret = WSH.Shell.Popup("݂̃Q[𒆒f܂H", 0, "mF", flag);
			if (ret == WSH.PopupResult.No) {
				Unlock();
				return;
			}
		}
		Playing = 0;
		// }XNA
		Field.clear();
		// fobO
		Debug.clear();
		Debug.count = 0;
		Debug.time = 0;
		// 쐬
		WSH.require("ExecRequest");
		var er = new WSH.ExecRequest();
		er.onload = function() {
			if (er.exitCode == 0) {
				var str = er.responseText;
				var lines = str.split("\n");
				var map = lines[1].replace(/\r|\n/, "").split(",");
				for ( var i = 0; i < map.length; i++) {
					if (map[i].match(/^\d{1,2}$/)) {
						var cell = new Cell(i);
						cell.setHint(true, map[i]);
					}
				}
				Playing = 1;
			} else {
				echo(location.href);
			}
			Unlock();
		};
		var cmd = CreateGameCmd + N + " " + N + " " + value;
		try {
			er.open(cmd);
		} catch (e) {
			var str = "[" + (e.number & 0xFFFF) + "]" + e.description;
			str += "\n";
			str += "Java 2 Runtime Environment̃CXg[mFĂB";

			WSH.require("Shell");
			var flag = WSH.PopupButtons.OKOnly | WSH.PopupIcon.Critical;
			WSH.Shell.Popup(str, 0, "G[", flag);

			Unlock();
		}
	};

	/**
	 * Button_Check.onclick Cxgnh
	 */
	this.Button_Check_OnClick = function(evt) {
		if (Playing != 2) {
			return;
		}

		// 킹
		Lock();
		var ret = NumberPlace.check();
		Unlock();

		if (ret === -1) {
			echo("𓚂܂B");
		} else if (ret === false) {
			echo("ԈĂƂ낪܂B");
		} else {
			echo("łI");
			Playing = 0;
		}
	};

	// ʂbN
	function Lock() {
		$$("body")[0].disabled = true;
	}
	// ʂ̃bN
	function Unlock() {
		$$("body")[0].disabled = false;
	}
}).apply(MyScript.prototype);

new MyScript();
